<!DOCTYPE html>
<html>

<head>
    <title>Lucky Dice Casino - Đinh Văn Cương</title>
    <meta charset='utf-8'>
    <meta name='viewport' content='width=device-width, initial-scale=1'>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- class CSS để dùng trong bài -->
    <style>
        .picture-cover {
            background-image: url("images/cover.jpg");
            min-height: 100px;
            margin: 5px;
        }
    </style>
</head>

<body>
    <div class="container-fluid  picture-cover">

    </div>
    <div class="container ">
        <div class="row ">
            <div class="col-5 bg-white  ">
                <div class="row  form-group">
                    <div class="col-12">
                        <!-- Tại dòng 2.1.1.1 thêm một div column rộng 12 đơn vị -->
                        <h4>Nhập thông tin của bạn</h4>
                    </div>
                </div>
                <div class="row   form-group">
                    <!-- tại mỗi dòng 2.1.1.2 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  ">
                        <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Username</label>
                    </div>
                    <div class="col-8  ">
                        <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-user-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row   form-group">
                    <!-- tại mỗi dòng 2.1.1.3 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  ">
                        <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Firstname</label>
                    </div>
                    <div class="col-8  ">
                        <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-first-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row   form-group">
                    <!-- tại mỗi dòng 2.1.1.4 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  ">
                        <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Lastname</label>
                    </div>
                    <div class="col-8  ">
                        <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-last-name" class="form-control" type="text">
                    </div>
                </div>
            </div>
            <div class="col-4  text-center">
                <!-- Tại cột 2.1.2 tạo 3 div class row, cột 2.1.2 có thuộc tính căn giữa -->
                <div class="row form-group">
                    <div class="col-12   ">
                        <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <input id="btn-dice" class="btn btn-success button-width w-75" value="Ném" type="button">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12   ">
                        <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị-->
                        <img id="img-dice" class="img-thumbnail" src="images/dice.png">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12   ">
                        <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <p id="p-notification-dice" class="text-primary">Chúc mừng</p>
                    </div>
                </div>
            </div>
            <div class="col-3  text-center">
                <!-- Tại cột 2.1.3 tạo 2 div class row, cột 2.1.3 có thuộc tính căn giữa -->
                <div class="row form-group">
                    <div class="col-12   ">
                        <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <p>Voucher</p>
                        <p id="p-voucher-id">No ID</p>
                        <p id="p-voucher-percent">0%</p>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12   ">
                        <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị-->
                        <img id="img-present" class="img-thumbnail" src="images/motobike.jpg">
                    </div>
                </div>
            </div>
        </div>
        <div class="row  text-center form-group">
            <!-- Tại row 2.2 thêm một div column rộng 12 đơn vị  -->
            <div class="col-12">
                <button id="btn-dice-history" class="btn btn-info button-width w-25">Dice History</button>
                <button id="btn-voucher-history" class="btn btn-success button-width w-25">Voucher History</button>
                <button id="btn-present-history" class="btn btn-success button-width w-25">Present History</button>
            </div>
        </div>
        <div class="row ">
            <!-- Tại row 2.3 thêm một div column rộng 12 đơn vị  -->
            <div class="col-12">
                <table id="history-placeholder-table" class="table table-striped table-hover ">
                    <tr>
                        <th>Lượt</th>
                        <th>Dice</th>
                    </tr>
                    <tr>
                        <td>1</td>
                        <td>2</td>
                    </tr>
                    <tr>
                        <td>2</td>
                        <td>6</td>
                    </tr>
                    <tr>
                        <td>3</td>
                        <td>4</td>
                    </tr>
                    <tr>
                        <td>4</td>
                        <td>5</td>
                    </tr>
                    <tr>
                        <td>5</td>
                        <td>4</td>
                    </tr>
                </table>
            </div>
        </div>
    </div>
</body>
<script>
    $(document).ready(function () {
        //REGION 1: GLOBAL VARIABLES - VÙNG KHAI BÁO BIẾN, HĂNG SỐ, THAM SỐ TOÀN CỤC
        const gREQUEST_READYSTATE_FINISH_RESPONSE_READY = 4;
        const gREQUEST_STATUS_OK = 200;
        const gEND_OF_TABLE = -1;
        const gCOL_LUOT = 0;
        const gCOL_DICE = 1;
        //base urlbaseUrk
        const vBaseUrl = "http://203.171.20.210:8080/devcamp-lucky-dice/";
        const vUtf8TextApplicationHeader = "application/json;charset=UTF-8";
        //REGION 2: GÁN/ THỰC THI SỰ KIỆN CỦA CÁC ELEMENTS
        //Khai báo hàm load trang
        onPageLoading();
        //Khai báo hàm xử lý sự kiện ném click
        $("#btn-dice").on("click", function () {
            onBtnNemClick();
        })
        //REGION 3: EVENTS HANDLERS - VÙNG KHAI BÁO CÁC HÀM XỬ LÝ SỰ KIỆN
        //Gọi hàm load trang
        function onPageLoading() {
            console.log("%cLoad trang tại đây", "color: blue");
        };
        //Gọi hàm xử lý sự kiện ném click
        function onBtnNemClick() {
            "use strict"
            console.log("Nút ném được ấn");
            //Khai báo đối tượng chứa thông tin nhập trên form
            var vUserObj = {
                userName: "",
                firstName: "",
                lastName: ""
            };

            //B1: Thu thập dữ liệu nhập trên form
            getDataToForm(vUserObj);
            //B2: Kiểm tra dữ liệu nhập trên form
            var vXmlHttpDice = new XMLHttpRequest();
            var vIsCheck = validateDataToForm(vUserObj);
            if (vIsCheck) {
                //B3: Gọi Api 
                callApiDataDiceNew(vXmlHttpDice, vUserObj);
                vXmlHttpDice.onreadystatechange = function () {
                    if (this.readyState == gREQUEST_READYSTATE_FINISH_RESPONSE_READY
                        && this.status == gREQUEST_STATUS_OK) {  //nếu trạng thái của response ready và ok
                        showConsoleLog(vXmlHttpDice);
                    }
                }

            }
        }
        //REGION 4: COMMON FUNCTIONS - VÙNG KHAI BÁO HÀM DÙNG CHUNG CHO TOÀN BỘ CHƯƠNG TRÌNH
        //Gọi hàm thu thập dữ liệu nhập trên form
        function getDataToForm(paramUserObj) {
            "use strict"
            var vInputUserName = $("#inp-user-name");
            var vInputFirstName = $("#inp-first-name");
            var vInputLastName = $("#inp-last-name");

            paramUserObj.userName = vInputUserName.val();
            paramUserObj.firstName = vInputFirstName.val();
            paramUserObj.lastName = vInputLastName.val();
        };
        //Gọi Hàm kiểm tra dữ liệu nhập trên form
        function validateDataToForm(paramUserObj) {
            "use strict"
            if (paramUserObj.userName == "") {
                alert("Bạn chưa nhập vào user name");
                return false;
            }
            if (paramUserObj.firstName == "") {
                alert("Bạn chưa nhập vào first name");
                return false;
            }
            if (paramUserObj.lastName == "") {
                alert("Bạn chưa nhập vào last name");
                return false;
            }
            return true;
        }
        //Gọi api
        function callApiDataDiceNew(paramXmlHttpDice, paramUserObj) {
            paramXmlHttpDice.open("POST", vBaseUrl + "/dice", true);
            paramXmlHttpDice.setRequestHeader("Content-Type", vUtf8TextApplicationHeader);
            paramXmlHttpDice.send(JSON.stringify(paramUserObj));  //chuyển Json object sang string
        }
        //gọi ham hiển thị 
        function showConsoleLog(paramXmlHttpDice) {
            console.log(paramXmlHttpDice.responseText);
            //random1To6(paramXmlHttpDice)
            var vResponseToObject = JSON.parse(paramXmlHttpDice.responseText);
            console.log(vResponseToObject);
            //get result dice
            var vDiceReady = vResponseToObject.dice;
            console.log("dice result: ", vDiceReady);
            //gọi hàm hiển thị dice
            changeDice(vDiceReady);
            //Gọi hàm hiển thị lời nhắn
            changeMessage(vDiceReady);
            //Gọi hàm hiển thị voucher
            changeVoucherId(vResponseToObject);
            //Gọi hàm hiển thị ảnh phần thưởng
            changeImg(vResponseToObject);
        }
        //Hàm hiển thị dice
        function changeDice(vDiceReady) {
            "use strict"
            var vImgDice = $("#img-dice");
            switch (vDiceReady) {
                case 1:
                    vImgDice.attr("src", "images/1.png");
                    break;
                case 2:
                    vImgDice.attr("src", "images/2.png");

                    break;
                case 3:
                    vImgDice.attr("src", "images/3.png");
                    break;
                case 4:
                    vImgDice.attr("src", "images/4.png");
                    break;
                case 5:
                    vImgDice.attr("src", "images/5.png");
                    break;
                default:
                    vImgDice.attr("src", "images/6.png");
            }
        }
        //Hàm hiển thị lời nhắn
        function changeMessage(paramDiceReady) {
            "use strict"
            var vChangeMessage = $("#p-notification-dice");
            if (paramDiceReady < 4) {
                vChangeMessage.html("Chúc bạn may mắn lần sau")
            }
            else {
                vChangeMessage.html("Chúc mừng bạn, hãy chơi ván nữa");
            }
        }
        //Hàm hiển thị voucher id
        function changeVoucherId(paramResponseVoucher) {
            "use strict"
            var vPVoucherId = $("#p-voucher-id");
            var vPVoucherPrecent = $("#p-voucher-percent");

            if (paramResponseVoucher.voucher != null) {
                vPVoucherId.html(paramResponseVoucher.voucher.maVoucher);
                vPVoucherPrecent.html(paramResponseVoucher.voucher.phanTramGiamGia + "%");
            }
            else {
                vPVoucherId.html("");
                vPVoucherPrecent.html("");
            }
        }
        //Hàm hiển thị ảnh phần thưởng
        function changeImg(paramResponsePrize) {
            "use strict"
            var vImgprecent = $("#img-present");
            var vTenPhanThuong = paramResponsePrize.prize;
            switch (vTenPhanThuong) {
                case "Mũ":
                    vImgprecent.attr("src", "images/hat.jpg");
                    break;
                case "Áo":
                    vImgprecent.attr("src", "images/t-shirt.jpg");
                    break;
                case "Xe máy":
                    vImgprecent.attr("src","images/xe-may.jpg");
                    break;
                case "Oto":
                    vImgprecent.attr("src", "images/car.jpg");
                    break;
                case "Xe đạp":
                    vImgprecent.attr("src", "images/bike.jpg");
                    break;
                default:
                    vImgprecent.attr("src", "images/no-present.jpg");
            }
        }
    })
</script>

</html>